package cn.com.infosec.asn1;

import cn.com.infosec.util.Strings;

public class DERUTF8String extends ASN1Object implements DERString {
   String string;

   public static DERUTF8String getInstance(Object obj) {
      if (obj != null && !(obj instanceof DERUTF8String)) {
         if (obj instanceof ASN1OctetString) {
            return new DERUTF8String(((ASN1OctetString)obj).getOctets());
         } else if (obj instanceof ASN1TaggedObject) {
            return getInstance(((ASN1TaggedObject)obj).getObject());
         } else {
            throw new IllegalArgumentException("illegal object in getInstance: " + obj.getClass().getName());
         }
      } else {
         return (DERUTF8String)obj;
      }
   }

   public static DERUTF8String getInstance(ASN1TaggedObject obj, boolean explicit) {
      return getInstance(obj.getObject());
   }

   DERUTF8String(byte[] string) {
      this.string = Strings.fromUTF8ByteArray(string);
   }

   public DERUTF8String(String string) {
      this.string = string;
   }

   public String getString() {
      return this.string;
   }

   public String toString() {
      return this.string;
   }

   public int hashCode() {
      return this.getString().hashCode();
   }

   boolean asn1Equals(DERObject o) {
      if (!(o instanceof DERUTF8String)) {
         return false;
      } else {
         DERUTF8String var10000 = this;
         DERUTF8String var2 = (DERUTF8String)o;
         return var10000.getString().equals(var2.getString());
      }
   }

   void encode(DEROutputStream out) {
      out.writeEncoded(12, Strings.toUTF8ByteArray(this.string));
   }
}
